/*
**	io.c
*/
#include "mpeg.h"
#include "disp.h"

int gx=0, gy=0;	/* geometry */
extern double grid_exp;  
extern double cur;
int cvw= 0;
#define CVW "CONTROLLED_VIDEO_WINDOW"
static char *p;

Ui tbc[TL];
int my[CN];
int mu[CN];
int mv[CN];
int mc[CN];
int cmr[CN];
int cmg[CN];
int cmb[CN];

int winw,winh;
int wx,wy;	/* window size */
int wix,wiy;	/* window image size */
int dx,dy,ddx,ddy,xys;
		/* dx,dy: coded image size,
		 ddx,ddy: draft image size */
/*
int (*disp)();
*/
int lbp=0;
int fg_pix, bg_pix;
int dep;
int dstx=0,dsty=0,incx=0,incy=0;
int grid= 0;
int scr;
int learn= 1;
char	*dd,*dd0;
Ui *zlinebuff;
static int expd[10]={64,57,57,0,33,57,57,57,57,61};
static int dh,dw;
Clp Q; 
Window rt,w1;
Display *dpy;
GC gc;
Colormap map,dmap;
XColor c1;
XImage *xi= NULL;
XEvent pe;
XGCValues xgcv;
XSetWindowAttributes xswa;
XWindowAttributes xwa;
XFontStruct *font_info;
Visual  *vis;

#ifdef SH_MEM
int	shm= 1;
int	CompletionType= -1;
XShmSegmentInfo shminfo;
static int	gXErrorFlag= 0;

HandleXError(dpy, event)
Display *dpy; XErrorEvent *event;
{ gXErrorFlag = 1; return 0; }
#endif

create_image(w, h)
	{
	if(xi!= NULL)destroy_image(xi); xi= NULL;
	if(w<8)w= 8;
	if(h==0)h= 1;
#ifdef SH_MEM
	shm= XShmQueryExtension(dpy);
	if(shm){
	XSetErrorHandler(HandleXError); XFlush(dpy);
	CompletionType = XShmGetEventBase(dpy)+ShmCompletion;
	xi= XShmCreateImage(dpy,vis,dep,ZPixmap,NULL,&shminfo,w,h);
	if(xi==NULL)goto shm_xci_err;
	shminfo.shmid =
	shmget(IPC_PRIVATE,(xi->bytes_per_line*xi->height),IPC_CREAT|0777);
	if (shminfo.shmid<0){fprintf(stderr,"Seg.id.%d\n",shminfo.shmid);
				goto shm_seg_err;}
	dd= xi->data= shminfo.shmaddr= (char *)shmat(shminfo.shmid,0,0);
	if(shminfo.shmaddr==((char *)-1)){
		fprintf(stderr, "Address.\n"); goto shm_adr_err; }
	shminfo.readOnly = False;

	XShmAttach(dpy, &shminfo);
	XSync(dpy, False);
	shmctl(shminfo.shmid, IPC_RMID, 0);
	XSetErrorHandler(NULL); XFlush(dpy);

	if(gXErrorFlag==0) return;
	gXErrorFlag= 0;
	shmdt(shminfo.shmaddr);
shm_adr_err: shmctl(shminfo.shmid, IPC_RMID, 0);
shm_seg_err: XDestroyImage(xi); xi= NULL;
shm_xci_err: fprintf(stderr, "Shared memory error, disabling.\n");
	shm= 0;
	}
#endif
	xi= XCreateImage(dpy,vis,dep,ZPixmap,0,NULL,w,h,32,0);
	xi->data= dd= (char *)malloc(xi->bytes_per_line*xi->height);
	}

destroy_image(xi)
XImage *xi;
	{
#ifdef SH_MEM
	if(shm) XShmDetach(dpy, &shminfo);
	XDestroyImage(xi);
	if(shm){
		shmdt(shminfo.shmaddr);
		shmctl(shminfo.shmid, IPC_RMID, 0);
		}
#else
	XDestroyImage(xi);
#endif
	}

#define T 256
#define U 512
#define clip(t) if(t<0)t=0;if(t>255)t=255

init_cl(ddt,x2)
	{
	int i,t;
	int rm,gm,bm;
	int rs,gs,bs;

	rm= vis->red_mask;
	gm= vis->green_mask;
	bm= vis->blue_mask;

	for(i=0;i<32;i++) if((rm <<i)&0x80000000)break; rs= i;
	for(i=0;i<32;i++) if((gm <<i)&0x80000000)break; gs= i;
	for(i=0;i<32;i++) if((bm <<i)&0x80000000)break; bs= i;

	if(ddt==9)
	for(i= -T;i<U;i++){
		t= i;
		if(cmp)t= (contrast*t+bright)>>16;
		t= ((t-16)*299)>>8;
		clip(t);
		t<<=24;
/*
		t= i; clip(t); t<<=24;
*/
		Q.r[i]= ((Ui)t>>rs)&rm;
		Q.g[i]= ((Ui)t>>gs)&gm;
		Q.b[i]= ((Ui)t>>bs)&bm;
		}
	else
	if((x2&1)==0)
	for(i= -T;i<U;i++){
#define M0	0
#define	M1	16
#define	M4	24
#define	M5	8
		Ui r,g,b;
		t= i-15+M0; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*M0; clip(t);	b= (t&0xc0)>>6;
		
		t= i-15+M1; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*M1; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+M4; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*M4; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+M5; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*M5; clip(t);	b|= (t&0xc0)<<18;
		Q.r[i]= r; Q.g[i]= g; Q.b[i]= b;
		}
	else if(x2==1)
	for(i= -T;i<U;i++){
		t= i-15; clip(t); Q.g[i]= (t & 0xe0)>>3;
		if(t<32)t=32;	  Q.r[i]= t & 0xe0;
		t= i-30; clip(t); Q.b[i]= t>>6;
		}
	else for(i= -T;i<U;i++){/* x2==3 */
		Ul r,g,b;
#ifdef Long64
		long t;
#endif
		t= i-15+4; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*4; clip(t);	b= (t&0xc0)>>6;
		
		t= i-15+12; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*12; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+28; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*28; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+20; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*20; clip(t);	b|= (t&0xc0)<<18;
#ifdef Long64
		t= i-15+8; clip(t);	g|= (t&0xe0)<<(32-3);
		if(t<32)t=32;		r|= (t&0xe0)<<32;
		t= i-30+2*8; clip(t);	b|= (t&0xc0)<<(32-6);

		t= i-15+16; clip(t);	g|= (t&0xe0)<<(40-3);
		if(t<32)t=32;		r|= (t&0xe0)<<40;
		t= i-30+2*16; clip(t);	b|= (t&0xc0)<<(40-6);

		t= i-15+24; clip(t);	g|= (t&0xe0)<<(48-3);
		if(t<32)t=32;		r|= (t&0xe0)<<48;
		t= i-30+2*24; clip(t);	b|= (t&0xc0)<<(48-6);

		t= i-15+0; clip(t);	g|= (t&0xe0)<<(56-3);
		if(t<32)t=32;		r|= (t&0xe0)<<56;
		t= i-30+2*0; clip(t);	b|= (t&0xc0)<<(56-6);
		*((Ul *)(&Q)+ 256+i)=		r;
		*((Ul *)(&Q)+1024+i)=		g;
		*((Ul *)(&Q)+1024+768+i)=	b;
#else
		Q.r[i]= r; Q.g[i]= g; Q.b[i]= b;
		t= i-15+8; clip(t);	g= (t&0xe0)>>3;
		if(t<32)t=32;		r= (t&0xe0);
		t= i-30+2*8; clip(t);	b= (t&0xc0)>>6;

		t= i-15+16; clip(t);	g|= (t&0xe0)<<5;
		if(t<32)t=32;		r|= (t&0xe0)<<8;
		t= i-30+2*16; clip(t);	b|= (t&0xc0)<<2;

		t= i-15+24; clip(t);	g|= (t&0xe0)<<13;
		if(t<32)t=32;		r|= (t&0xe0)<<16;
		t= i-30+2*24; clip(t);	b|= (t&0xc0)<<10;

		t= i-15+0; clip(t);	g|= (t&0xe0)<<21;
		if(t<32)t=32;		r|= (t&0xe0)<<24;
		t= i-30+2*0; clip(t);	b|= (t&0xc0)<<18;
		Q.y[i]= r; Q.u[i]= g; Q.v[i]= b;
#endif
		}

	for(i= -T;i<U;i++){
		t= i; clip(t); Q.cl[i]= t; Q.sq[i]= i*i;
		}
	}

iwt(name, sif, dhs, dvs)
char	*name;
unsigned char *sif;
	{
	int i,j;
	int x,y,u,v;
	static int new= 1;
	XVisualInfo vinfo;

	ddx= dhs; ddy= dvs;
	dx= (ddx+15)&(~15);
	dy= (ddy+15)&(~15);
	xys= dx*dy;

	if(new){
		if( (dpy= XOpenDisplay("")) == NULL){
			fprintf(stderr,"Display open error.\n");
			exit(1);
			}
		scr=	DefaultScreen(dpy);
		dep=	DisplayPlanes(dpy,scr);
		rt=	RootWindow(dpy,scr);
		fg_pix= WhitePixel(dpy,scr);
		bg_pix= BlackPixel(dpy,scr);
		dh=	DisplayHeight(dpy,scr);
		dw=	DisplayWidth(dpy,scr);
		if(dep<=8){
			if(XMatchVisualInfo(dpy,scr,8,PseudoColor,&vinfo)) { vis = vinfo.visual; ddt= 0; }
			else { fprintf(stderr,"Requires 8 bit PseudoColor visual\n"); exit(1); }
		} else {
			if(XMatchVisualInfo(dpy,scr,dep,TrueColor,&vinfo)) { vis = vinfo.visual; ddt= FullColor; }
			else { fprintf(stderr,"Requires %d bit TrueColor visual\n",dep); exit(1); }
		}
		/*
		font_info= XLoadQueryFont(dpy,"times_italic10");
		*/
		zlinebuff= (Ui *)malloc(2048*4);
		init_cl(ddt,x2);
		}
	else free(dd0);

	     if(dep>16) lbp= 2;
	else if(dep> 8) lbp= 1;
	dd0= (char *)malloc((dx*ddy)<<lbp);

	color_map_set(0,0);
	if(ddt!=FullColor) XInstallColormap(dpy,map);

	wx= ddx*x2; wy= ddy*x2;
	//if(wx > dw-20)wx= dw-20;
	if(wy > dh-20)wy= dh-20;
	winw= wx; winh= wy;

	x= dx*x2; y= ddy*x2;
	if(x&3)x-= x&3;
	//if(x > dw-20)x= dw-20;
	if(y > dh-20)y= dh-20;
	if(y&1)y--;
	wix= x; wiy= y;
	create_image(x,y);
	init_cl(ddt,x2);

	xswa.event_mask = ExposureMask | StructureNotifyMask;
	xswa.background_pixel=	bg_pix;
	xswa.colormap = (ddt==FullColor)?
		XCreateColormap(dpy,rt,vis,AllocNone):map;
	xswa.backing_store = NotUseful;

	if(p = getenv(CVW)){
		int wid,x,y;
		sscanf(p,"0x%x+%d+%d-%d-%d",&wid,&dstx,&dsty,&x,&y);
		incx= dstx+x;
		incy= dsty+y;
		w1= wid;
		XChangeWindowAttributes(dpy,w1,CWEventMask|CWColormap,&xswa);
		XResizeWindow(dpy,w1,winw+incx,winh+incy);
		cvw= 1;
		}
	else if(new){
		if(gx==0&&gy==0){ gx= (dw-wx)>>1; gy= (dh-wy)>>1; }
		w1=XCreateWindow(dpy,rt,gx,gy,wx,wy,1,dep,InputOutput,vis,
		(CWEventMask|CWBackPixel|CWColormap|CWBackingStore), &xswa);
		}
	else XResizeWindow(dpy,w1,winw,winh);

	XChangeProperty(dpy, w1, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
			name, strlen(name));

	if(new==0) return;

	if(cvw) XSelectInput(dpy, w1, StructureNotifyMask);
	else XSelectInput(dpy, w1, ButtonPressMask | ButtonReleaseMask
		| PointerMotionMask | StructureNotifyMask);

	xgcv.foreground = fg_pix;
	xgcv.function = GXcopy;
	xgcv.plane_mask = AllPlanes;
	xgcv.fill_style = FillSolid;
	xgcv.graphics_exposures = True;
	gc = XCreateGC(dpy, w1, GCForeground | GCFunction | GCPlaneMask |
				GCFillStyle | GCGraphicsExposures, &xgcv);
	if (cvw==0) {
		XGetWindowAttributes(dpy,w1,&xwa);
		if(xwa.map_state!=IsViewable){
		    XMapWindow(dpy, w1);
			XMoveWindow(dpy,w1,gx,gy);
		    while(1){
			XNextEvent(dpy, &pe);
			if(pe.type == MapNotify && pe.xmap.event == w1)break;
			}
		    }
		}
	new= 0;
	}

wt(name,sif)
char *name;
unsigned char *sif;
	{
	int t; char *save;

//#ifdef Debug
	XChangeProperty(dpy, w1, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
			name, strlen(name));
//#endif
	/*
	if(deb)post(sif,dx,dy);
	*/
	if(t=expd[ddt]&(1<<x2)){save= dd;dd= dd0;winw= dx;winh= ddy;}
	switch(ddt){
		case 0: if(x2==1) disp0 (sif);
		else	if(x2==2) disp02(sif);
		else	if(x2==3) disp03(sif);
		else	if(x2==4) disp04(sif);
		else	disp3z(sif); break;
		case 9: disp9(sif);
		default: break;
		}
	if(t){expand(dd0,save,wx,wy,lbp,zlinebuff);winw= wx;winh= wy;dd= save;}

	if(grid){
		if(cur>= grid_exp){ grid=0; color_map_set(0,1);}
		 else mkgrid();
		}
#ifdef SH_MEM
	if(shm){
		XShmPutImage(dpy,w1,gc,xi,0,0,dstx,dsty,wix,wiy,1);
		while(1){
			XNextEvent(dpy, &pe); events();
			if(pe.type == CompletionType)break;
			}
	} else {
#endif
	 	XPutImage(dpy,w1,gc,xi,0,0,dstx,dsty,wix,wiy);
		while(XCheckMaskEvent(dpy,
		ButtonReleaseMask | PointerMotionMask |
		ButtonPressMask | StructureNotifyMask,  &pe)) events();
#ifdef SH_MEM
		}
#endif
	}

events()
	{
	     if(pe.type == ButtonRelease) button_off();
	else if(pe.type == ButtonPress) button_on();
	else if(pe.type == MotionNotify) lever();
	else if(pe.type == ConfigureNotify) var_size();
	}
